package main;

import main.Main;

import java.io.*;
import java.util.ArrayList;

public class Config
{
	public String iwad = "";
	public String font = "";
	public int[] translation = {0,0,0};
	public int[] translation_green = {0,0,0};
	public int[] translation_white = {0,0,0};
	public ArrayList<String> mobj = new ArrayList<String>();

	public Config(String config)
	{
		try
		{
			BufferedReader in = new BufferedReader(new FileReader(config));
			String line = null;
			while((line = in.readLine()) != null)
			{
				if(line.indexOf("//") != -1)
				{
					line = line.substring(0, line.indexOf("//"));
				}
				if(line.indexOf("=") != -1)
				{
					String setting = line.substring(0, line.indexOf("=")).trim();
					String value = line.substring(line.indexOf("=")+1).trim();
					parseSetting(setting, value);
				}
			}
			in.close();
		}
		catch(Exception e) //fatal error
		{
			Main.fatalError(e, "Could not read the config file.");
		}
	}

	private void parseSetting(String setting, String value) throws Exception
	{
		if(setting.equals("iwad"))
		{
			iwad = value;
		}
		else if(setting.equals("font"))
		{
			font = value;
		}
		else if(setting.equals("font_remap_default"))
		{
			translation[0] = Integer.parseInt(value.substring(0, value.indexOf(":")));
			translation[1] = Integer.parseInt(value.substring(value.indexOf(":")+1, value.indexOf(",")));
			translation[2] = Integer.parseInt(value.substring(value.indexOf(",")+1).trim());
		}
		else if(setting.equals("font_remap_green"))
		{
			translation_green[0] = Integer.parseInt(value.substring(0, value.indexOf(":")));
			translation_green[1] = Integer.parseInt(value.substring(value.indexOf(":")+1, value.indexOf(",")));
			translation_green[2] = Integer.parseInt(value.substring(value.indexOf(",")+1).trim());
		}
		else if(setting.equals("font_remap_white"))
		{
			translation_white[0] = Integer.parseInt(value.substring(0, value.indexOf(":")));
			translation_white[1] = Integer.parseInt(value.substring(value.indexOf(":")+1, value.indexOf(",")));
			translation_white[2] = Integer.parseInt(value.substring(value.indexOf(",")+1).trim());
		}
		else if(setting.equals("mobj"))
		{
			mobj.add(value);
		}
	}
}